// CustomDrawingDoc.cpp : implementation of the CCustomDrawingDoc class
//

#include "stdafx.h"
#include "CustomDrawing.h"

#include "CustomDrawingDoc.h"
#include <Dapfor/Common/LongDateFormat.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomDrawingDoc

IMPLEMENT_DYNCREATE(CCustomDrawingDoc, CDocument)

BEGIN_MESSAGE_MAP(CCustomDrawingDoc, CDocument)
    //{{AFX_MSG_MAP(CCustomDrawingDoc)
        // NOTE - the ClassWizard will add and remove mapping macros here.
        //    DO NOT EDIT what you see in these blocks of generated code!
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()


DF_BEGIN_FIELD_MAP(CCustomDrawingDoc)
	DF_LONG_ID  (FidOrdersCount,     _T("Orders count"),  &CCustomDrawingDoc::GetOrdersCount, 0, 0)
    DF_LONG_ID  (FidObjectType, _T("Object type"),   &CCustomDrawingDoc::GetObjectType,  0, 0)
DF_END_FIELD_MAP()
   

/////////////////////////////////////////////////////////////////////////////
// CCustomDrawingDoc construction/destruction

CCustomDrawingDoc::CCustomDrawingDoc()
{
	for(int i = 0; i < 100; ++i)
	{
		//Create a new order with random parameters
		COrder* order = new COrder((CProductManager::Product)(CProductManager::USBHub + (rand() % 6)), 
			rand() % 3 + 1, 
			Dapfor::Common::CLongDateFormat::Now() + (long)CTimeSpan(rand() % 7 -3, 0, 0, 0).GetTotalSeconds(),
			(COrder::Status)(COrder::Ordered + (rand() % 4)));
		
		//Add the new order to the container
		m_Orders.push_back(order);
	}
}

CCustomDrawingDoc::~CCustomDrawingDoc()
{
	for(Orders::iterator it = m_Orders.begin(); it != m_Orders.end(); ++it)
	{
		delete * it;
	}
}

BOOL CCustomDrawingDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

	SetTitle(_T("Dapfor"));

    return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CCustomDrawingDoc serialization

void CCustomDrawingDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
    }
    else
    {
        // TODO: add loading code here
    }
}

/////////////////////////////////////////////////////////////////////////////
// CCustomDrawingDoc diagnostics

#ifdef _DEBUG
void CCustomDrawingDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CCustomDrawingDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCustomDrawingDoc commands


const CCustomDrawingDoc::Orders& CCustomDrawingDoc::GetOrders() const
{
    return m_Orders;
}

long CCustomDrawingDoc::GetOrdersCount() const
{
	return m_Orders.size();
}

long CCustomDrawingDoc::GetObjectType() const
{
	return Document;
}