// CustomDrawingDoc.h : interface of the CCustomDrawingDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CUSTOMDRAWINGDOC_H__3DD4FD3D_4E5A_4811_91C5_361143A092D3__INCLUDED_)
#define AFX_CUSTOMDRAWINGDOC_H__3DD4FD3D_4E5A_4811_91C5_361143A092D3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "Order.h"
#include "Types.h"


//////////////////////////////////////////////////////////////////////////
// This class contains a list of orders. 
// Note that the grid can work with pratically any class. If we derive this class from the CDataObject, then
// the instance of the class may be shown in the grid.
// This example demonstrates how the document may be inserted into the grid and how to show 
// a number of orders in the non-scrollable area of the grid.
//////////////////////////////////////////////////////////////////////////
class CCustomDrawingDoc : public Dapfor::Common::CDataObject,
						  public CDocument
{
public:
    typedef std::vector<COrder*> Orders;

	enum Fields
	{
		//The common fields
		FidCommonFields = FidObjectType,

		//Fields, reserved only for the CCustomDrawingDoc class
		FidOrdersCount = FidDocumentBase,
	};

protected: // create from serialization only
    CCustomDrawingDoc();
    DECLARE_DYNCREATE(CCustomDrawingDoc)

// Attributes
public:

// Operations
public:

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CCustomDrawingDoc)
    public:
    virtual BOOL OnNewDocument();
    virtual void Serialize(CArchive& ar);
    //}}AFX_VIRTUAL

    const Orders& GetOrders() const;
	long GetOrdersCount() const;
	long GetObjectType() const;

// Implementation
public:
    virtual ~CCustomDrawingDoc();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
    Orders m_Orders;


    //{{AFX_MSG(CCustomDrawingDoc)
        // NOTE - the ClassWizard will add and remove member functions here.
        //    DO NOT EDIT what you see in these blocks of generated code !
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
	DF_DECLARE_FIELD_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CUSTOMDRAWINGDOC_H__3DD4FD3D_4E5A_4811_91C5_361143A092D3__INCLUDED_)
