#pragma once

#include "Types.h"
#include <Dapfor/Common/DataObject.h>

using namespace Dapfor;

//Instances of this class are added to the upper grid.
class CTestObject : public Common::CDataObject
{
public:
    //Available fields
    enum Fields
    {
        FidName,
        Fid1,
        Fid2,
        Fid3,
        Fid4,
        Fid5,
        Fid6,
        Fid7,
        Fid8,
        Fid9,
        Fid10,
    };

public:
    //Constructor
    CTestObject(const TString& name);

    //The function evaluates a random field (Fid1..Fid10)
    void EvaluateRandomField();
    
    //Public methods
    TString GetName() const;
    long GetValue1() const;
    long GetValue2() const;
    long GetValue3() const;
    long GetValue4() const;
    long GetValue5() const;
    long GetValue6() const;
    long GetValue7() const;
    long GetValue8() const;
    long GetValue9() const;
    long GetValue10() const;

private:
    //Private fields

    TString m_Name;
    long m_Value1;
    long m_Value2;
    long m_Value3;
    long m_Value4;
    long m_Value5;
    long m_Value6;
    long m_Value7;
    long m_Value8;
    long m_Value9;
    long m_Value10;

private:
    //Declaration of accessors to functions of this class by their identifiers (Fields enumeration)
    DF_DECLARE_FIELD_MAP();
};
