/////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2007-2008 Dapfor
//                                                                         
// This file is part of the Dapfor software, and may only be used, modified, and distributed 
// under the terms of the Dapfor Software License, Version 1.0.
// (See accompanying file lisense.txt or open the license at www.dapfor.com/license_agreement.aspx)
// By continuing to use, modify, or distribute this file you indicate that you have read the license 
// and understand and accept it fully.
/////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once


#include <Dapfor/Common/Common.h>

namespace Dapfor
{

namespace Common
{

class CAutomat; 


//////////////////////////////////////////////////////////////////////////
/// \brief Abstract job to be executed in CAutomat
/// 
/// Automat calls ProcessJob in its own thread and after that destroys the job object.
///
/// \class CJob Job.h <Dapfor/Common/Job.h>
//////////////////////////////////////////////////////////////////////////
class DF_COMMON_API CJob
{
public:
    virtual ~CJob(); //!< Virtual destructor

    /// This function is called to execute a job in CAutomat thread.
    virtual void ProcessJob(CAutomat* automat) = 0; 
};

}//namespace Common

}//namespace Dapfor

