/////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2007-2008 Dapfor
//                                                                         
// This file is part of the Dapfor software, and may only be used, modified, and distributed 
// under the terms of the Dapfor Software License, Version 1.0.
// (See accompanying file lisense.txt or open the license at www.dapfor.com/license_agreement.aspx)
// By continuing to use, modify, or distribute this file you indicate that you have read the license 
// and understand and accept it fully.
/////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Dapfor/GUI/IHeaderPaintFormat.h>

namespace Dapfor
{
namespace GUI
{

//////////////////////////////////////////////////////////////////////////
///\brief Default implementation of IHeaderPaintFormat interface.
///
/// \version <b>1.0.0.0</b> Initial version
///
/// \class  CHeaderPaintFormat HeaderPaintFormat.h Dapfor/GUI/HeaderPaintFormat.h
/// \file HeaderPaintFormat.h
//////////////////////////////////////////////////////////////////////////
class DF_GUI_API CHeaderPaintFormat : public IHeaderPaintFormat
{
public:
    CHeaderPaintFormat();   //!< Constructor
    ~CHeaderPaintFormat();  //!< Destructor

    // Draws a header in CGrid.
    virtual void DrawHeader(CHeaderPaintInfo& paintInfo, const CPaintContext& paintContext, UINT paintFilter, ICustomDraw* customDraw) const;

private:
    DF_DECLARE_HEADER_PAINT_FORMAT();
};

}//namespace GUI

}//namespace Dapfor

