/////////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2007-2008 Dapfor
//                                                                         
// This file is part of the Dapfor software, and may only be used, modified, and distributed 
// under the terms of the Dapfor Software License, Version 1.0.
// (See accompanying file lisense.txt or open the license at www.dapfor.com/license_agreement.aspx)
// By continuing to use, modify, or distribute this file you indicate that you have read the license 
// and understand and accept it fully.
/////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include <Dapfor/GUI/Tooltip.h>

namespace Dapfor
{
namespace GUI
{


//////////////////////////////////////////////////////////////////////////////////////////////
/// \brief ITooltip implementation that presents a cell's content as a html-formatted text
///
/// Formats a text of the data object returned by Common::CDataObject::GetFormattedString() into a html 
/// form and returns it.
///
/// \version <b>1.0.0.0</b> Initial version
/// 
/// \class  CHtmlTooltip HtmlTooltip.h Dapfor/GUI/HtmlTooltip.h
/// \file HtmlTooltip.h
//////////////////////////////////////////////////////////////////////////////////////////////
class DF_GUI_API CHtmlTooltip : public CTooltip
{
public:
    ///Constructor
    CHtmlTooltip(bool autoDelete);

    // Gets a text to display it in the tooltip.
    TString GetText(const CGrid& grid, const CGridCell& cell) const;
};

}

}//namespace Dapfor
